"use strict";

const BaseValidatorException = require("./BaseValidatorException");

module.exports = 
class BaseValidator
{
	constructor()
	{
		throw new Error("BaseValidator is a static class and cannot be instantiated.");
	}
	
	static isValid(mxValue)
	{
		try
		{
			return this.assertValid(mxValue);
		}
		catch(error)
		{
			return false;
		}
	}
	
	static assertValid(mxValue)
	{
		throw new Error(`Method "assertValid" must be implemented in class ${this.name}.`);
	}

	/**
	* Utility function.
	* Should only output "OK" to the console if the validator is working properly
	*/
	static test()
	{
		console.warn(`There is no test implemented in class ${this.name}.`);
	}
};
