const DomainNameValidator = require("../DomainName/DomainNameValidator");
const DomainNameValidatorException = require("../DomainName/DomainNameValidatorException");
const ProductSubdomainNameValidatorException = require("./ProductSubdomainNameValidatorException");

module.exports =
class ProductSubdomainNameValidator extends DomainNameValidator
{
	static assertValid(strDomainName, bAllowNonIANATLD, bAllowIPs)
	{
		strDomainName = strDomainName.toLowerCase();

		if(strDomainName.length === 0)
		{
			throw new ProductSubdomainNameValidatorException("Labels must have at lest one character.", ProductSubdomainNameValidatorException.LABEL_MUST_HAVE_AT_LEAST_1_CHARACTER);
		}

		if(!(/^[a-z]{1,1}$/.test(strDomainName[0])))
		{
			throw new ProductSubdomainNameValidatorException("Labels must start with a letter.", ProductSubdomainNameValidatorException.LABEL_CONTAINS_DISALLOWED_CHARACTERS);
		}

		try
		{
			return super.assertValid(strDomainName, bAllowNonIANATLD, bAllowIPs);
		}
		catch(e)
		{
			if(e instanceof DomainNameValidatorException)
			{
				throw new ProductSubdomainNameValidatorException(e.message, e.code);
			}

			throw e;
		}
	}

	static assertValidLabel(strDomainNameLabel)
	{
		strDomainNameLabel = strDomainNameLabel.toLowerCase();

		if(strDomainNameLabel.length === 0)
		{
			throw new ProductSubdomainNameValidatorException("Labels must have at lest one character.", ProductSubdomainNameValidatorException.LABEL_MUST_HAVE_AT_LEAST_1_CHARACTER);
		}

		if(!(/^[a-z]{1,1}$/.test(strDomainNameLabel[0])))
		{
			throw new ProductSubdomainNameValidatorException("Labels must start with a letter.", ProductSubdomainNameValidatorException.LABEL_CONTAINS_DISALLOWED_CHARACTERS);
		}

		try
		{
			return super.assertValidLabel(strDomainNameLabel);
		}
		catch(e)
		{
			if(e instanceof DomainNameValidatorException)
			{
				throw new ProductSubdomainNameValidatorException(e.message, e.code);
			}

			throw e;
		}
	}

	static test()
	{
		super.test();
		//TODO implement specific tests
		console.warn(`There are no SPECIFIC tests implemented in "${this.name}" class!!`);
	}
}
