"use strict";

const BaseValidatorException = require("../Base/BaseValidatorException");

module.exports =
class TimestampValidatorException extends BaseValidatorException
{
	constructor(strMessage, nCode = 0)
	{
		super(strMessage, nCode);
	}

	/**
	* Date must be a string.
	*/
	static get DATE_MUST_BE_STRING() { return 0; }

	/**
	* Date format not good.
	* Desired format is: YYYY-MM-DDThh:mm:ssZ
	*/
	static get DATE_MUST_BE_ISO8601_COMPLIANT() { return 1; }

	/**
	* Invalid date.
	*/
	static get INVALID_DATE() { return 2; }

	/**
	* Invalid time.
	*/
	static get INVALID_TIME() { return 3; }
};
