"use strict";

const CacheResult = require("./CacheResult");

module.exports =
class CacheInterface
{
    constructor()
    {
        throw new Error("CacheInterface cannot be instantiated because it is an Interface.");
    }

     /**
     * Fetch the value of a cache key.
     * 
     * @returns {CacheResult}
     */
    async fetch(strCacheKey)
    {
        throw new Error(`Method not implemented in CacheEngine child class ${this.constructor.name}.`);
    }
    

   /**
     * Sets the value of a cache key.
     * 
     * @param {String} strCacheKey
     * @param {*} mxValue
     * @param {Integer} nValidSeconds = null
     */
    async store(strCacheKey, mxValue, nValidSeconds = null)
    {
        throw new Error(`Method not implemented in CacheEngine child class ${this.constructor.name}.`);
    }

    /**
     * Expires a key.
     * 
     * @param {String} strCacheKey 
     */
    async expire(strCacheKey)
    {
        throw new Error(`Method not implemented in CacheEngine child class ${this.constructor.name}.`);
    }
    
    /**
     * Clear all cache data.
     */
    async destroy()
    {
        throw new Error(`Method not implemented in CacheEngine child class ${this.constructor.name}.`);
    }
}