# Node JS Mail utilities

Utilities class for sending mails. It is a wrapper for [nodemailer](https://nodemailer.com) library.

# Configure

```js
let objConfig = {
    hostname: "HOST_NAME",
    port: 25,
    username: "USER_NAME",
    password: "PASSWORD",
    from: {
        email: "FROM_EMAIL",
        displayName: "FROM_DISPLAY_NAME"
    },
    secure: true,
    tls: {
        // do not fail on invalid certs
        // rejectUnauthorized: false
    },
    debug: true
};
```

```js
//Static
Mail.configStatic = objConfig;

// OR configure a new instance
let mailInstance = new Mail(objConfig);
```


# Usage

https://nodemailer.com/message/
```js
let objMessage = {
    from: {
        displayName: "MY_DISPLAY_NAME",
        email: "MY_EMAIL"
    },
    to: "SENDER DISPLAY NAME <sender.email@example.com>", //or directly the email address "sender.email@example.com"
    subject: "Mail test subject",
    text: 'Plaintext version of the message',
    html: '<p>HTML version of the message</p>'
};


//Static usage
await Mail.sendMailStatic(objMessage);

//OR send from new Mail instance
let mailInstance = new Mail(objConfig);
await mailInstance.sendMail(objMessage);
```
