module.exports =
class Utils
{
	constructor()
	{
		throw new Error("Utils is a static class and cannot be instantiated.");
	}

	/**
	 * @param {string} strJSON
	 * @returns {Object}
	 * @throws {SyntaxError}
	 */
	static safeJSONParse(strJSON)
	{
		let objResult = null;

		try
		{
			objResult = JSON.parse(strJSON);
		}
		catch(error)
		{
			throw new Error("Failed parsing JSON string with error message: " + error.stack);
		}

		return objResult;
	}
}

